// XApp.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "XApp.h"

#include "MainFrm.h"
#include "XDoc.h"
#include "XView.h"

#include "dx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CXApp

BEGIN_MESSAGE_MAP(CXApp, CWinApp)
	//{{AFX_MSG_MAP(CXApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXApp construction

CXApp::CXApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CXApp object

CXApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CXApp initialization

BOOL CXApp::InitInstance()
{
	AfxEnableControlContainer();
	
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.
	
#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif
	
	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("DJ Software"));
	
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)
	
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.
	
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CXDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CXView));
	AddDocTemplate(pDocTemplate);
	
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	
	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	
	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	
	// Initialize DirectX stuff.
	ClearX();
	if (!InitX(m_pMainWnd->GetSafeHwnd()))
	{
		TRACE("CXApp::InitInstance(): InitX failed.\n");
		AfxMessageBox("Failed to initialize DirectX.\n");
		return FALSE;
	}
	((CMainFrame*)m_pMainWnd)->RecalcLayout(TRUE);

	LPDIRECT3DRMFRAME pFrame;
	pFrame = LoadFrame("cube.x");
	if (pFrame) {
		g_pScene->AddChild(pFrame);
		pFrame->SetRotation(pFrame, D3DVAL(1.0), D3DVAL(0.5), D3DVAL(0.2), D3DVAL(0.05));
	}else{
		AfxMessageBox("Fooey. No cube.");
	}
	g_pCamera->SetPosition(g_pScene, D3DVAL(0.0), D3DVAL(0.0), D3DVAL(-350.0));

	// InitX succeeded. Start animating.
	SetActive(TRUE);
	
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CXApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CXApp commands

BOOL CXApp::HeartBeat(DWORD dwCount)
{
	if (g_bUse3D) {
		g_pD3DRM->Tick(D3DVAL(dwCount));
	}else{
		// Variables for the blocks color, in RGB format
		static r = 0;
		static g = 0;
		static b = 0;
		
		r++;
		if (r > 255)
		{
			r = 0;
			g++;
			if (g > 255)
			{
				g = 0;
				b++;
				if (b > 255)
					b = 0;
			}
		}
		
		// The destination rectangle on the off-screen surface
		CRect rc(10,10,g_szBack.cx - 20,g_szBack.cy - 20);
		
		// We draw the rectangle using a blit.
		// This structure describes how to do the blit.
		DDBLTFX fx;
		// Zero out all fields of the blit effects structure
		memset(&fx, 0, sizeof(fx));
		// The dwSize field must contain the size of the structure
		fx.dwSize = sizeof(DDBLTFX);
		
		// Set the color we want to draw the rectangle
		fx.dwFillColor = RGB(r,g,b);
		
		// Blit. Note that we blit to the back buffer
		HRESULT hr;
		hr = g_pDDSBack->Blt(&rc, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &fx);
		if (Failed(hr)) {
			TRACE("Error blitting: %s\n", ErrorToString(hr));
			return FALSE;
		}
	}

	// Flip the back to the front
	DDFlip();

	return TRUE;
}

BOOL CXApp::OnIdle(LONG lCount) 
{
	CWinApp::OnIdle(lCount);
	if (GetActive())
	{
		HeartBeat((DWORD)1);
//		Sleep(200);
	}
	return TRUE;
	
//	return CWinApp::OnIdle(lCount);
}
